BEGIN;

\timing

CREATE OR REPLACE FUNCTION public.gen_data_users(in_user_count INTEGER)
RETURNS void
AS $$
DECLARE
  v_counter INTEGER := 0;
BEGIN

  FOR v_counter IN 1 .. in_user_count
  LOOP
    INSERT INTO public.users
      (first_name, middle_name, last_name)
        SELECT (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text));

  END LOOP;
  RETURN;
END;
$$ language plpgsql;

SELECT public.gen_data_users(50000);

CREATE OR REPLACE FUNCTION public.gen_data_mailto_addresses()
RETURNS void
AS $$
BEGIN

    INSERT INTO public.mailto_addresses
      (user_id, mailto_1_first_name, mailto_1_middle_name, mailto_1_last_org_name,
       mailto_1_address_1, mailto_1_address_2, mailto_1_city, mailto_1_state,
       mailto_1_zipcode, mailto_2_first_name, mailto_2_middle_name, mailto_2_last_org_name,
       mailto_2_address_1, mailto_2_address_2, mailto_2_city, mailto_2_state,
       mailto_2_zipcode, mailto_3_first_name, mailto_3_middle_name, mailto_3_last_org_name,
       mailto_3_address_1, mailto_3_address_2, mailto_3_city, mailto_3_state,
       mailto_3_zipcode, mailto_4_first_name, mailto_4_middle_name, mailto_4_last_org_name,
       mailto_4_address_1, mailto_4_address_2, mailto_4_city, mailto_4_state,
       mailto_4_zipcode, mailto_5_first_name, mailto_5_middle_name, mailto_5_last_org_name,
       mailto_5_address_1, mailto_5_address_2, mailto_5_city, mailto_5_state,
       mailto_5_zipcode, mailto_6_first_name, mailto_6_middle_name, mailto_6_last_org_name,
       mailto_6_address_1, mailto_6_address_2, mailto_6_city, mailto_6_state,
       mailto_6_zipcode, mailto_7_first_name, mailto_7_middle_name, mailto_7_last_org_name,
       mailto_7_address_1, mailto_7_address_2, mailto_7_city, mailto_7_state,
       mailto_7_zipcode, mailto_8_first_name, mailto_8_middle_name, mailto_8_last_org_name,
       mailto_8_address_1, mailto_8_address_2, mailto_8_city, mailto_8_state,
       mailto_8_zipcode, mailto_9_first_name, mailto_9_middle_name, mailto_9_last_org_name,
       mailto_9_address_1, mailto_9_address_2, mailto_9_city, mailto_9_state,
       mailto_9_zipcode, mailto_10_first_name, mailto_10_middle_name, mailto_10_last_org_name,
       mailto_10_address_1, mailto_10_address_2, mailto_10_city, mailto_10_state,
       mailto_10_zipcode)
        SELECT pu.user_id, (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)),
               (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), (md5((random()*100000000)::text)), substring((md5((random()*100000000)::text)) from 1 for 2),
               (md5((random()*100000000)::text))
          FROM public.users pu;

  RETURN;
END;
$$ language plpgsql;

SELECT public.gen_data_mailto_addresses();

COMMIT;
