BEGIN;

ALTER TABLE public.mailto_addresses RENAME TO mailto_addresses_orig;

CREATE VIEW public.mailto_addresses AS
  SELECT user_id,
         mailto_1_first_name,
         mailto_1_middle_name,
         mailto_1_last_org_name,
         mailto_1_address_1,
         mailto_1_address_2,
         mailto_1_city,
         mailto_1_state,
         mailto_1_zipcode,
         mailto_2_first_name,
         mailto_2_middle_name,
         mailto_2_last_org_name,
         mailto_2_address_1,
         mailto_2_address_2,
         mailto_2_city,
         mailto_2_state,
         mailto_2_zipcode,
         mailto_3_first_name,
         mailto_3_middle_name,
         mailto_3_last_org_name,
         mailto_3_address_1,
         mailto_3_address_2,
         mailto_3_city,
         mailto_3_state,
         mailto_3_zipcode,
         mailto_4_first_name,
         mailto_4_middle_name,
         mailto_4_last_org_name,
         mailto_4_address_1,
         mailto_4_address_2,
         mailto_4_city,
         mailto_4_state,
         mailto_4_zipcode,
         mailto_5_first_name,
         mailto_5_middle_name,
         mailto_5_last_org_name,
         mailto_5_address_1,
         mailto_5_address_2,
         mailto_5_city,
         mailto_5_state,
         mailto_5_zipcode,
         mailto_6_first_name,
         mailto_6_middle_name,
         mailto_6_last_org_name,
         mailto_6_address_1,
         mailto_6_address_2,
         mailto_6_city,
         mailto_6_state,
         mailto_6_zipcode,
         mailto_7_first_name,
         mailto_7_middle_name,
         mailto_7_last_org_name,
         mailto_7_address_1,
         mailto_7_address_2,
         mailto_7_city,
         mailto_7_state,
         mailto_7_zipcode,
         mailto_8_first_name,
         mailto_8_middle_name,
         mailto_8_last_org_name,
         mailto_8_address_1,
         mailto_8_address_2,
         mailto_8_city,
         mailto_8_state,
         mailto_8_zipcode,
         mailto_9_first_name,
         mailto_9_middle_name,
         mailto_9_last_org_name,
         mailto_9_address_1,
         mailto_9_address_2,
         mailto_9_city,
         mailto_9_state,
         mailto_9_zipcode,
         mailto_10_first_name,
         mailto_10_middle_name,
         mailto_10_last_org_name,
         mailto_10_address_1,
         mailto_10_address_2,
         mailto_10_city,
         mailto_10_state,
         mailto_10_zipcode
    FROM public.mailto_addresses_orig;

CREATE FUNCTION insert_mailto_address(in_mailto_address mailto_addresses)
  RETURNS void
  LANGUAGE 'plpgsql' AS
$body$
BEGIN
  INSERT INTO mailto_addresses_orig
    (user_id, mailto_1_first_name, mailto_1_middle_name, mailto_1_last_org_name,
     mailto_1_address_1, mailto_1_address_2, mailto_1_city, mailto_1_state,
     mailto_1_zipcode, mailto_2_first_name, mailto_2_middle_name, mailto_2_last_org_name,
     mailto_2_address_1, mailto_2_address_2, mailto_2_city, mailto_2_state,
     mailto_2_zipcode, mailto_3_first_name, mailto_3_middle_name, mailto_3_last_org_name,
     mailto_3_address_1, mailto_3_address_2, mailto_3_city, mailto_3_state,
     mailto_3_zipcode, mailto_4_first_name, mailto_4_middle_name, mailto_4_last_org_name,
     mailto_4_address_1, mailto_4_address_2, mailto_4_city, mailto_4_state,
     mailto_4_zipcode, mailto_5_first_name, mailto_5_middle_name, mailto_5_last_org_name,
     mailto_5_address_1, mailto_5_address_2, mailto_5_city, mailto_5_state,
     mailto_5_zipcode, mailto_6_first_name, mailto_6_middle_name, mailto_6_last_org_name,
     mailto_6_address_1, mailto_6_address_2, mailto_6_city, mailto_6_state,
     mailto_6_zipcode, mailto_7_first_name, mailto_7_middle_name, mailto_7_last_org_name,
     mailto_7_address_1, mailto_7_address_2, mailto_7_city, mailto_7_state,
     mailto_7_zipcode, mailto_8_first_name, mailto_8_middle_name, mailto_8_last_org_name,
     mailto_8_address_1, mailto_8_address_2, mailto_8_city, mailto_8_state,
     mailto_8_zipcode, mailto_9_first_name, mailto_9_middle_name, mailto_9_last_org_name,
     mailto_9_address_1, mailto_9_address_2, mailto_9_city, mailto_9_state,
     mailto_9_zipcode, mailto_10_first_name, mailto_10_middle_name, mailto_10_last_org_name,
     mailto_10_address_1, mailto_10_address_2, mailto_10_city, mailto_10_state,
     mailto_10_zipcode)
    VALUES
    (in_mailto_address.user_id, in_mailto_address.mailto_1_first_name, in_mailto_address.mailto_1_middle_name, in_mailto_address.mailto_1_last_org_name,
     in_mailto_address.mailto_1_address_1, in_mailto_address.mailto_1_address_2, in_mailto_address.mailto_1_city, in_mailto_address.mailto_1_state,
     in_mailto_address.mailto_1_zipcode, in_mailto_address.mailto_2_first_name, in_mailto_address.mailto_2_middle_name, in_mailto_address.mailto_2_last_org_name,
     in_mailto_address.mailto_2_address_1, in_mailto_address.mailto_2_address_2, in_mailto_address.mailto_2_city, in_mailto_address.mailto_2_state,
     in_mailto_address.mailto_2_zipcode, in_mailto_address.mailto_3_first_name, in_mailto_address.mailto_3_middle_name, in_mailto_address.mailto_3_last_org_name,
     in_mailto_address.mailto_3_address_1, in_mailto_address.mailto_3_address_2, in_mailto_address.mailto_3_city, in_mailto_address.mailto_3_state,
     in_mailto_address.mailto_3_zipcode, in_mailto_address.mailto_4_first_name, in_mailto_address.mailto_4_middle_name, in_mailto_address.mailto_4_last_org_name,
     in_mailto_address.mailto_4_address_1, in_mailto_address.mailto_4_address_2, in_mailto_address.mailto_4_city, in_mailto_address.mailto_4_state,
     in_mailto_address.mailto_4_zipcode, in_mailto_address.mailto_5_first_name, in_mailto_address.mailto_5_middle_name, in_mailto_address.mailto_5_last_org_name,
     in_mailto_address.mailto_5_address_1, in_mailto_address.mailto_5_address_2, in_mailto_address.mailto_5_city, in_mailto_address.mailto_5_state,
     in_mailto_address.mailto_5_zipcode, in_mailto_address.mailto_6_first_name, in_mailto_address.mailto_6_middle_name, in_mailto_address.mailto_6_last_org_name,
     in_mailto_address.mailto_6_address_1, in_mailto_address.mailto_6_address_2, in_mailto_address.mailto_6_city, in_mailto_address.mailto_6_state,
     in_mailto_address.mailto_6_zipcode, in_mailto_address.mailto_7_first_name, in_mailto_address.mailto_7_middle_name, in_mailto_address.mailto_7_last_org_name,
     in_mailto_address.mailto_7_address_1, in_mailto_address.mailto_7_address_2, in_mailto_address.mailto_7_city, in_mailto_address.mailto_7_state,
     in_mailto_address.mailto_7_zipcode, in_mailto_address.mailto_8_first_name, in_mailto_address.mailto_8_middle_name, in_mailto_address.mailto_8_last_org_name,
     in_mailto_address.mailto_8_address_1, in_mailto_address.mailto_8_address_2, in_mailto_address.mailto_8_city, in_mailto_address.mailto_8_state,
     in_mailto_address.mailto_8_zipcode, in_mailto_address.mailto_9_first_name, in_mailto_address.mailto_9_middle_name, in_mailto_address.mailto_9_last_org_name,
     in_mailto_address.mailto_9_address_1, in_mailto_address.mailto_9_address_2, in_mailto_address.mailto_9_city, in_mailto_address.mailto_9_state,
     in_mailto_address.mailto_9_zipcode, in_mailto_address.mailto_10_first_name, in_mailto_address.mailto_10_middle_name, in_mailto_address.mailto_10_last_org_name,
     in_mailto_address.mailto_10_address_1, in_mailto_address.mailto_10_address_2, in_mailto_address.mailto_10_city, in_mailto_address.mailto_10_state,
     in_mailto_address.mailto_10_zipcode);

  RETURN;

END;
$body$;

CREATE FUNCTION update_mailto_address(in_new_row mailto_addresses, in_old_row mailto_addresses)
  RETURNS void
  LANGUAGE 'plpgsql' AS
$body$
BEGIN

  UPDATE mailto_addresses_orig
     SET (user_id, mailto_1_first_name, mailto_1_middle_name, mailto_1_last_org_name,
          mailto_1_address_1, mailto_1_address_2, mailto_1_city, mailto_1_state,
          mailto_1_zipcode, mailto_2_first_name, mailto_2_middle_name, mailto_2_last_org_name,
          mailto_2_address_1, mailto_2_address_2, mailto_2_city, mailto_2_state,
          mailto_2_zipcode, mailto_3_first_name, mailto_3_middle_name, mailto_3_last_org_name,
          mailto_3_address_1, mailto_3_address_2, mailto_3_city, mailto_3_state,
          mailto_3_zipcode, mailto_4_first_name, mailto_4_middle_name, mailto_4_last_org_name,
          mailto_4_address_1, mailto_4_address_2, mailto_4_city, mailto_4_state,
          mailto_4_zipcode, mailto_5_first_name, mailto_5_middle_name, mailto_5_last_org_name,
          mailto_5_address_1, mailto_5_address_2, mailto_5_city, mailto_5_state,
          mailto_5_zipcode, mailto_6_first_name, mailto_6_middle_name, mailto_6_last_org_name,
          mailto_6_address_1, mailto_6_address_2, mailto_6_city, mailto_6_state,
          mailto_6_zipcode, mailto_7_first_name, mailto_7_middle_name, mailto_7_last_org_name,
          mailto_7_address_1, mailto_7_address_2, mailto_7_city, mailto_7_state,
          mailto_7_zipcode, mailto_8_first_name, mailto_8_middle_name, mailto_8_last_org_name,
          mailto_8_address_1, mailto_8_address_2, mailto_8_city, mailto_8_state,
          mailto_8_zipcode, mailto_9_first_name, mailto_9_middle_name, mailto_9_last_org_name,
          mailto_9_address_1, mailto_9_address_2, mailto_9_city, mailto_9_state,
          mailto_9_zipcode, mailto_10_first_name, mailto_10_middle_name, mailto_10_last_org_name,
          mailto_10_address_1, mailto_10_address_2, mailto_10_city, mailto_10_state,
          mailto_10_zipcode)
          = (in_new_row.user_id, in_new_row.mailto_1_first_name, in_new_row.mailto_1_middle_name, in_new_row.mailto_1_last_org_name,
             in_new_row.mailto_1_address_1, in_new_row.mailto_1_address_2, in_new_row.mailto_1_city, in_new_row.mailto_1_state,
             in_new_row.mailto_1_zipcode, in_new_row.mailto_2_first_name, in_new_row.mailto_2_middle_name, in_new_row.mailto_2_last_org_name,
             in_new_row.mailto_2_address_1, in_new_row.mailto_2_address_2, in_new_row.mailto_2_city, in_new_row.mailto_2_state,
             in_new_row.mailto_2_zipcode, in_new_row.mailto_3_first_name, in_new_row.mailto_3_middle_name, in_new_row.mailto_3_last_org_name,
             in_new_row.mailto_3_address_1, in_new_row.mailto_3_address_2, in_new_row.mailto_3_city, in_new_row.mailto_3_state,
             in_new_row.mailto_3_zipcode, in_new_row.mailto_4_first_name, in_new_row.mailto_4_middle_name, in_new_row.mailto_4_last_org_name,
             in_new_row.mailto_4_address_1, in_new_row.mailto_4_address_2, in_new_row.mailto_4_city, in_new_row.mailto_4_state,
             in_new_row.mailto_4_zipcode, in_new_row.mailto_5_first_name, in_new_row.mailto_5_middle_name, in_new_row.mailto_5_last_org_name,
             in_new_row.mailto_5_address_1, in_new_row.mailto_5_address_2, in_new_row.mailto_5_city, in_new_row.mailto_5_state,
             in_new_row.mailto_5_zipcode, in_new_row.mailto_6_first_name, in_new_row.mailto_6_middle_name, in_new_row.mailto_6_last_org_name,
             in_new_row.mailto_6_address_1, in_new_row.mailto_6_address_2, in_new_row.mailto_6_city, in_new_row.mailto_6_state,
             in_new_row.mailto_6_zipcode, in_new_row.mailto_7_first_name, in_new_row.mailto_7_middle_name, in_new_row.mailto_7_last_org_name,
             in_new_row.mailto_7_address_1, in_new_row.mailto_7_address_2, in_new_row.mailto_7_city, in_new_row.mailto_7_state,
             in_new_row.mailto_7_zipcode, in_new_row.mailto_8_first_name, in_new_row.mailto_8_middle_name, in_new_row.mailto_8_last_org_name,
             in_new_row.mailto_8_address_1, in_new_row.mailto_8_address_2, in_new_row.mailto_8_city, in_new_row.mailto_8_state,
             in_new_row.mailto_8_zipcode, in_new_row.mailto_9_first_name, in_new_row.mailto_9_middle_name, in_new_row.mailto_9_last_org_name,
             in_new_row.mailto_9_address_1, in_new_row.mailto_9_address_2, in_new_row.mailto_9_city, in_new_row.mailto_9_state,
             in_new_row.mailto_9_zipcode, in_new_row.mailto_10_first_name, in_new_row.mailto_10_middle_name, in_new_row.mailto_10_last_org_name,
             in_new_row.mailto_10_address_1, in_new_row.mailto_10_address_2, in_new_row.mailto_10_city, in_new_row.mailto_10_state,
             in_new_row.mailto_10_zipcode)
  WHERE user_id = in_old_row.user_id;

  RETURN;

END;
$body$;

CREATE FUNCTION delete_mailto_address(in_old_row mailto_addresses)
  RETURNS void
  LANGUAGE 'sql' AS
$body$

  DELETE FROM mailto_addresses_orig
   WHERE user_id = $1.user_id;
$body$;

CREATE RULE mailto_addresses_insert_rl AS
    ON INSERT
    TO public.mailto_addresses
    DO INSTEAD
       SELECT public.insert_mailto_address(new.*);

CREATE RULE mailto_addresses_update_rl AS
    ON UPDATE
    TO public.mailto_addresses
    DO INSTEAD
       SELECT public.update_mailto_address(new.*, old.*);
 
CREATE RULE mailto_address_delete_rl AS
    ON DELETE
    TO public.mailto_addresses
    DO INSTEAD
       SELECT public.delete_mailto_address(old.*);

COMMIT;
