BEGIN;

CREATE OR REPLACE VIEW public.mailto_addresses AS
  SELECT user_id,
         mailto_1_first_name,
         mailto_1_middle_name,
         mailto_1_last_org_name,
         mailto_1_address_1,
         mailto_1_address_2,
         mailto_1_city,
         mailto_1_state,
         mailto_1_zipcode,
         mailto_2_first_name,
         mailto_2_middle_name,
         mailto_2_last_org_name,
         mailto_2_address_1,
         mailto_2_address_2,
         mailto_2_city,
         mailto_2_state,
         mailto_2_zipcode,
         mailto_3_first_name,
         mailto_3_middle_name,
         mailto_3_last_org_name,
         mailto_3_address_1,
         mailto_3_address_2,
         mailto_3_city,
         mailto_3_state,
         mailto_3_zipcode,
         mailto_4_first_name,
         mailto_4_middle_name,
         mailto_4_last_org_name,
         mailto_4_address_1,
         mailto_4_address_2,
         mailto_4_city,
         mailto_4_state,
         mailto_4_zipcode,
         mailto_5_first_name,
         mailto_5_middle_name,
         mailto_5_last_org_name,
         mailto_5_address_1,
         mailto_5_address_2,
         mailto_5_city,
         mailto_5_state,
         mailto_5_zipcode,
         mailto_6_first_name,
         mailto_6_middle_name,
         mailto_6_last_org_name,
         mailto_6_address_1,
         mailto_6_address_2,
         mailto_6_city,
         mailto_6_state,
         mailto_6_zipcode,
         mailto_7_first_name,
         mailto_7_middle_name,
         mailto_7_last_org_name,
         mailto_7_address_1,
         mailto_7_address_2,
         mailto_7_city,
         mailto_7_state,
         mailto_7_zipcode,
         mailto_8_first_name,
         mailto_8_middle_name,
         mailto_8_last_org_name,
         mailto_8_address_1,
         mailto_8_address_2,
         mailto_8_city,
         mailto_8_state,
         mailto_8_zipcode,
         mailto_9_first_name,
         mailto_9_middle_name,
         mailto_9_last_org_name,
         mailto_9_address_1,
         mailto_9_address_2,
         mailto_9_city,
         mailto_9_state,
         mailto_9_zipcode,
         mailto_10_first_name,
         mailto_10_middle_name,
         mailto_10_last_org_name,
         mailto_10_address_1,
         mailto_10_address_2,
         mailto_10_city,
         mailto_10_state,
         mailto_10_zipcode
    FROM public.mailto_addresses_orig
   WHERE NOT is_migrated 
         OR is_migrated IS NULL
UNION ALL
  SELECT m01.user_id,
         m01.first_name AS mailto_1_first_name,
         m01.middle_name AS mailto_1_middle_name,
         m01.last_org_name AS mailto_1_last_org_name,
         m01.address_1 AS mailto_1_address_1,
         m01.address_2 AS mailto_1_address_2,
         m01.city AS mailto_1_city,
         m01.state AS mailto_1_state,
         m01.zipcode AS mailto_1_zipcode,
         m02.first_name AS mailto_2_first_name,
         m02.middle_name AS mailto_2_middle_name,
         m02.last_org_name AS mailto_2_last_org_name,
         m02.address_1 AS mailto_2_address_1,
         m02.address_2 AS mailto_2_address_2,
         m02.city AS mailto_2_city,
         m02.state AS mailto_2_state,
         m02.zipcode AS mailto_2_zipcode,
         m03.first_name AS mailto_3_first_name,
         m03.middle_name AS mailto_3_middle_name,
         m03.last_org_name AS mailto_3_last_org_name,
         m03.address_1 AS mailto_3_address_1,
         m03.address_2 AS mailto_3_address_2,
         m03.city AS mailto_3_city,
         m03.state AS mailto_3_state,
         m03.zipcode AS mailto_3_zipcode,
         m04.first_name AS mailto_4_first_name,
         m04.middle_name AS mailto_4_middle_name,
         m04.last_org_name AS mailto_4_last_org_name,
         m04.address_1 AS mailto_4_address_1,
         m04.address_2 AS mailto_4_address_2,
         m04.city AS mailto_4_city,
         m04.state AS mailto_4_state,
         m04.zipcode AS mailto_4_zipcode,
         m05.first_name AS mailto_5_first_name,
         m05.middle_name AS mailto_5_middle_name,
         m05.last_org_name AS mailto_5_last_org_name,
         m05.address_1 AS mailto_5_address_1,
         m05.address_2 AS mailto_5_address_2,
         m05.city AS mailto_5_city,
         m05.state AS mailto_5_state,
         m05.zipcode AS mailto_5_zipcode,
         m06.first_name AS mailto_6_first_name,
         m06.middle_name AS mailto_6_middle_name,
         m06.last_org_name AS mailto_6_last_org_name,
         m06.address_1 AS mailto_6_address_1,
         m06.address_2 AS mailto_6_address_2,
         m06.city AS mailto_6_city,
         m06.state AS mailto_6_state,
         m06.zipcode AS mailto_6_zipcode,
         m07.first_name AS mailto_7_first_name,
         m07.middle_name AS mailto_7_middle_name,
         m07.last_org_name AS mailto_7_last_org_name,
         m07.address_1 AS mailto_7_address_1,
         m07.address_2 AS mailto_7_address_2,
         m07.city AS mailto_7_city,
         m07.state AS mailto_7_state,
         m07.zipcode AS mailto_7_zipcode,
         m08.first_name AS mailto_8_first_name,
         m08.middle_name AS mailto_8_middle_name,
         m08.last_org_name AS mailto_8_last_org_name,
         m08.address_1 AS mailto_8_address_1,
         m08.address_2 AS mailto_8_address_2,
         m08.city AS mailto_8_city,
         m08.state AS mailto_8_state,
         m08.zipcode AS mailto_8_zipcode,
         m09.first_name AS mailto_9_first_name,
         m09.middle_name AS mailto_9_middle_name,
         m09.last_org_name AS mailto_9_last_org_name,
         m09.address_1 AS mailto_9_address_1,
         m09.address_2 AS mailto_9_address_2,
         m09.city AS mailto_9_city,
         m09.state AS mailto_9_state,
         m09.zipcode AS mailto_9_zipcode,
         m10.first_name AS mailto_10_first_name,
         m10.middle_name AS mailto_10_middle_name,
         m10.last_org_name AS mailto_10_last_org_name,
         m10.address_1 AS mailto_10_address_1,
         m10.address_2 AS mailto_10_address_2,
         m10.city AS mailto_10_city,
         m10.state AS mailto_10_state,
         m10.zipcode AS mailto_10_zipcode
    FROM public.user_mailing_addresses m01
    LEFT JOIN public.user_mailing_addresses m02 ON m01.user_id = m02.user_id AND m02.sort_key=2
    LEFT JOIN public.user_mailing_addresses m03 ON m01.user_id = m03.user_id AND m03.sort_key=3
    LEFT JOIN public.user_mailing_addresses m04 ON m01.user_id = m04.user_id AND m04.sort_key=4
    LEFT JOIN public.user_mailing_addresses m05 ON m01.user_id = m05.user_id AND m05.sort_key=5
    LEFT JOIN public.user_mailing_addresses m06 ON m01.user_id = m06.user_id AND m06.sort_key=6
    LEFT JOIN public.user_mailing_addresses m07 ON m01.user_id = m07.user_id AND m07.sort_key=7
    LEFT JOIN public.user_mailing_addresses m08 ON m01.user_id = m08.user_id AND m08.sort_key=8
    LEFT JOIN public.user_mailing_addresses m09 ON m01.user_id = m09.user_id AND m09.sort_key=9
    LEFT JOIN public.user_mailing_addresses m10 ON m01.user_id = m10.user_id AND m10.sort_key=10
   WHERE m01.sort_key = 1;


CREATE OR REPLACE FUNCTION insert_mailto_address(in_new_row mailto_addresses)
  RETURNS void
  LANGUAGE 'plpgsql' AS
$body$
BEGIN

  --  See which mailto addresses are populated and insert them
  --  into the normalized public.user_mailing_addresses table
  --  Always insert the first record, even if there is no data for this
  --  address.  The view depends on the user_id in sort_key 1
  INSERT INTO public.user_mailing_addresses
    (user_id, first_name, middle_name, last_org_name,
     address_1, address_2, city, state, zipcode, sort_key)
    VALUES
      (in_new_row.user_id, in_new_row.mailto_1_first_name, in_new_row.mailto_1_middle_name, in_new_row.mailto_1_last_org_name,
       in_new_row.mailto_1_address_1, in_new_row.mailto_1_address_2, in_new_row.mailto_1_city, in_new_row.mailto_1_state, in_new_row.mailto_1_zipcode, 1);

  IF in_new_row.mailto_2_first_name IS NOT NULL 
     OR in_new_row.mailto_2_middle_name IS NOT NULL
     OR in_new_row.mailto_2_last_org_name IS NOT NULL
     OR in_new_row.mailto_2_address_1 IS NOT NULL 
     OR in_new_row.mailto_2_address_2 IS NOT NULL 
     OR in_new_row.mailto_2_city IS NOT NULL 
     OR in_new_row.mailto_2_state IS NOT NULL 
     OR in_new_row.mailto_2_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_2_first_name, in_new_row.mailto_2_middle_name, in_new_row.mailto_2_last_org_name,
         in_new_row.mailto_2_address_1, in_new_row.mailto_2_address_2, in_new_row.mailto_2_city, in_new_row.mailto_2_state, in_new_row.mailto_2_zipcode, 2);
  END IF;

  IF in_new_row.mailto_3_first_name IS NOT NULL
     OR in_new_row.mailto_3_middle_name IS NOT NULL
     OR in_new_row.mailto_3_last_org_name IS NOT NULL
     OR in_new_row.mailto_3_address_1 IS NOT NULL
     OR in_new_row.mailto_3_address_2 IS NOT NULL
     OR in_new_row.mailto_3_city IS NOT NULL
     OR in_new_row.mailto_3_state IS NOT NULL
     OR in_new_row.mailto_3_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_3_first_name, in_new_row.mailto_3_middle_name, in_new_row.mailto_3_last_org_name,
         in_new_row.mailto_3_address_1, in_new_row.mailto_3_address_2, in_new_row.mailto_3_city, in_new_row.mailto_3_state, in_new_row.mailto_3_zipcode, 3);
  END IF;

  IF in_new_row.mailto_4_first_name IS NOT NULL
     OR in_new_row.mailto_4_middle_name IS NOT NULL
     OR in_new_row.mailto_4_last_org_name IS NOT NULL
     OR in_new_row.mailto_4_address_1 IS NOT NULL
     OR in_new_row.mailto_4_address_2 IS NOT NULL
     OR in_new_row.mailto_4_city IS NOT NULL
     OR in_new_row.mailto_4_state IS NOT NULL
     OR in_new_row.mailto_4_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_4_first_name, in_new_row.mailto_4_middle_name, in_new_row.mailto_4_last_org_name,
         in_new_row.mailto_4_address_1, in_new_row.mailto_4_address_2, in_new_row.mailto_4_city, in_new_row.mailto_4_state, in_new_row.mailto_4_zipcode, 4);
  END IF;

  IF in_new_row.mailto_5_first_name IS NOT NULL
     OR in_new_row.mailto_5_middle_name IS NOT NULL
     OR in_new_row.mailto_5_last_org_name IS NOT NULL
     OR in_new_row.mailto_5_address_1 IS NOT NULL
     OR in_new_row.mailto_5_address_2 IS NOT NULL
     OR in_new_row.mailto_5_city IS NOT NULL
     OR in_new_row.mailto_5_state IS NOT NULL
     OR in_new_row.mailto_5_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_5_first_name, in_new_row.mailto_5_middle_name, in_new_row.mailto_5_last_org_name,
         in_new_row.mailto_5_address_1, in_new_row.mailto_5_address_2, in_new_row.mailto_5_city, in_new_row.mailto_5_state, in_new_row.mailto_5_zipcode, 5);
  END IF;

  IF in_new_row.mailto_6_first_name IS NOT NULL
     OR in_new_row.mailto_6_middle_name IS NOT NULL
     OR in_new_row.mailto_6_last_org_name IS NOT NULL
     OR in_new_row.mailto_6_address_1 IS NOT NULL
     OR in_new_row.mailto_6_address_2 IS NOT NULL
     OR in_new_row.mailto_6_city IS NOT NULL
     OR in_new_row.mailto_6_state IS NOT NULL
     OR in_new_row.mailto_6_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_6_first_name, in_new_row.mailto_6_middle_name, in_new_row.mailto_6_last_org_name,
         in_new_row.mailto_6_address_1, in_new_row.mailto_6_address_2, in_new_row.mailto_6_city, in_new_row.mailto_6_state, in_new_row.mailto_6_zipcode, 6);
  END IF;

  IF in_new_row.mailto_7_first_name IS NOT NULL
     OR in_new_row.mailto_7_middle_name IS NOT NULL
     OR in_new_row.mailto_7_last_org_name IS NOT NULL
     OR in_new_row.mailto_7_address_1 IS NOT NULL
     OR in_new_row.mailto_7_address_2 IS NOT NULL
     OR in_new_row.mailto_7_city IS NOT NULL
     OR in_new_row.mailto_7_state IS NOT NULL
     OR in_new_row.mailto_7_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_7_first_name, in_new_row.mailto_7_middle_name, in_new_row.mailto_7_last_org_name,
         in_new_row.mailto_7_address_1, in_new_row.mailto_7_address_2, in_new_row.mailto_7_city, in_new_row.mailto_7_state, in_new_row.mailto_7_zipcode, 7);
  END IF;

  IF in_new_row.mailto_8_first_name IS NOT NULL
     OR in_new_row.mailto_8_middle_name IS NOT NULL
     OR in_new_row.mailto_8_last_org_name IS NOT NULL
     OR in_new_row.mailto_8_address_1 IS NOT NULL
     OR in_new_row.mailto_8_address_2 IS NOT NULL
     OR in_new_row.mailto_8_city IS NOT NULL
     OR in_new_row.mailto_8_state IS NOT NULL
     OR in_new_row.mailto_8_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_8_first_name, in_new_row.mailto_8_middle_name, in_new_row.mailto_8_last_org_name,
         in_new_row.mailto_8_address_1, in_new_row.mailto_8_address_2, in_new_row.mailto_8_city, in_new_row.mailto_8_state, in_new_row.mailto_8_zipcode, 8);
  END IF;

  IF in_new_row.mailto_9_first_name IS NOT NULL
     OR in_new_row.mailto_9_middle_name IS NOT NULL
     OR in_new_row.mailto_9_last_org_name IS NOT NULL
     OR in_new_row.mailto_9_address_1 IS NOT NULL
     OR in_new_row.mailto_9_address_2 IS NOT NULL
     OR in_new_row.mailto_9_city IS NOT NULL
     OR in_new_row.mailto_9_state IS NOT NULL
     OR in_new_row.mailto_9_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_9_first_name, in_new_row.mailto_9_middle_name, in_new_row.mailto_9_last_org_name,
         in_new_row.mailto_9_address_1, in_new_row.mailto_9_address_2, in_new_row.mailto_9_city, in_new_row.mailto_9_state, in_new_row.mailto_9_zipcode, 9);
  END IF;

  IF in_new_row.mailto_10_first_name IS NOT NULL
     OR in_new_row.mailto_10_middle_name IS NOT NULL
     OR in_new_row.mailto_10_last_org_name IS NOT NULL
     OR in_new_row.mailto_10_address_1 IS NOT NULL
     OR in_new_row.mailto_10_address_2 IS NOT NULL
     OR in_new_row.mailto_10_city IS NOT NULL
     OR in_new_row.mailto_10_state IS NOT NULL
     OR in_new_row.mailto_10_zipcode IS NOT NULL
  THEN
    INSERT INTO public.user_mailing_addresses
      (user_id, first_name, middle_name, last_org_name,
       address_1, address_2, city, state, zipcode, sort_key)
      VALUES
        (in_new_row.user_id, in_new_row.mailto_10_first_name, in_new_row.mailto_10_middle_name, in_new_row.mailto_10_last_org_name,
         in_new_row.mailto_10_address_1, in_new_row.mailto_10_address_2, in_new_row.mailto_10_city, in_new_row.mailto_10_state, in_new_row.mailto_10_zipcode, 10);
  END IF;

  RETURN;

END;
$body$;


CREATE OR REPLACE FUNCTION update_mailto_address(in_new_row mailto_addresses, in_old_row mailto_addresses)
  RETURNS void
  LANGUAGE 'plpgsql' AS
$body$
BEGIN

  RAISE DEBUG 'Updateding mailto_addresses_orig setting is_migrated = true.';
  -- update the mailto_addresses_orig and set is_migrated to true.
  UPDATE public.mailto_addresses_orig
     SET is_migrated = TRUE
   WHERE user_id = in_old_row.user_id
         AND (is_migrated = FALSE 
             OR is_migrated IS NULL);

  IF FOUND THEN
    PERFORM insert_mailto_address(in_new_row);
  ELSE
    -- For each address set, check to see of there are any changes.  If there are, try and update.
    -- If the update returns FALSE, insert the record.
    IF in_new_row.mailto_1_first_name IS DISTINCT FROM in_old_row.mailto_1_first_name 
       OR in_new_row.mailto_1_middle_name IS DISTINCT FROM in_old_row.mailto_1_middle_name
       OR in_new_row.mailto_1_last_org_name IS DISTINCT FROM in_old_row.mailto_1_last_org_name
       OR in_new_row.mailto_1_address_1 IS DISTINCT FROM in_old_row.mailto_1_address_1
       OR in_new_row.mailto_1_address_2 IS DISTINCT FROM in_old_row.mailto_1_address_2
       OR in_new_row.mailto_1_city IS DISTINCT FROM in_old_row.mailto_1_city
       OR in_new_row.mailto_1_state IS DISTINCT FROM in_old_row.mailto_1_state
       OR in_new_row.mailto_1_zipcode IS DISTINCT FROM in_old_row.mailto_1_zipcode
    THEN
      UPDATE public.user_mailing_addresses
         SET (first_name, middle_name, last_org_name,
              address_1, address_2, city, state, zipcode)
             = (in_new_row.mailto_1_first_name, in_new_row.mailto_1_middle_name, in_new_row.mailto_1_last_org_name,
                in_new_row.mailto_1_address_1, in_new_row.mailto_1_address_2, in_new_row.mailto_1_city, in_new_row.mailto_1_state, in_new_row.mailto_1_zipcode)
       WHERE user_id = in_old_row.user_id
             AND sort_key = 1;
  
      IF NOT FOUND THEN
        INSERT INTO public.user_mailing_addresses
          (user_id, first_name, middle_name, last_org_name,
           address_1, address_2, city, state, zipcode, sort_key)
          VALUES
             (in_new_row.user_id, in_new_row.mailto_1_first_name, in_new_row.mailto_1_middle_name, in_new_row.mailto_1_last_org_name,
              in_new_row.mailto_1_address_1, in_new_row.mailto_1_address_2, in_new_row.mailto_1_city, in_new_row.mailto_1_state, in_new_row.mailto_1_zipcode, 1);
      END IF;
    END IF;
          
    IF in_new_row.mailto_2_first_name IS DISTINCT FROM in_old_row.mailto_2_first_name 
       OR in_new_row.mailto_2_middle_name IS DISTINCT FROM in_old_row.mailto_2_middle_name
       OR in_new_row.mailto_1_last_org_name IS DISTINCT FROM in_old_row.mailto_2_last_org_name
       OR in_new_row.mailto_2_address_1 IS DISTINCT FROM in_old_row.mailto_2_address_1
       OR in_new_row.mailto_2_address_2 IS DISTINCT FROM in_old_row.mailto_2_address_2
       OR in_new_row.mailto_2_city IS DISTINCT FROM in_old_row.mailto_2_city
       OR in_new_row.mailto_2_state IS DISTINCT FROM in_old_row.mailto_2_state
       OR in_new_row.mailto_2_zipcode IS DISTINCT FROM in_old_row.mailto_2_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_2_first_name, in_new_row.mailto_2_middle_name, in_new_row.mailto_2_last_org_name,
              in_new_row.mailto_2_address_1, in_new_row.mailto_2_address_2, in_new_row.mailto_2_city, in_new_row.mailto_2_state, in_new_row.mailto_2_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 2;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_2_first_name, in_new_row.mailto_2_middle_name, in_new_row.mailto_2_last_org_name,
            in_new_row.mailto_2_address_1, in_new_row.mailto_2_address_2, in_new_row.mailto_2_city, in_new_row.mailto_2_state, in_new_row.mailto_2_zipcode, 2);
    END IF;
  END IF;

  IF in_new_row.mailto_3_first_name IS DISTINCT FROM in_old_row.mailto_3_first_name 
     OR in_new_row.mailto_3_middle_name IS DISTINCT FROM in_old_row.mailto_3_middle_name
     OR in_new_row.mailto_3_last_org_name IS DISTINCT FROM in_old_row.mailto_3_last_org_name
     OR in_new_row.mailto_3_address_1 IS DISTINCT FROM in_old_row.mailto_3_address_1
     OR in_new_row.mailto_3_address_2 IS DISTINCT FROM in_old_row.mailto_3_address_2
     OR in_new_row.mailto_3_city IS DISTINCT FROM in_old_row.mailto_3_city
     OR in_new_row.mailto_3_state IS DISTINCT FROM in_old_row.mailto_3_state
     OR in_new_row.mailto_3_zipcode IS DISTINCT FROM in_old_row.mailto_3_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_3_first_name, in_new_row.mailto_3_middle_name, in_new_row.mailto_3_last_org_name,
              in_new_row.mailto_3_address_1, in_new_row.mailto_3_address_2, in_new_row.mailto_3_city, in_new_row.mailto_3_state, in_new_row.mailto_3_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 3;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_3_first_name, in_new_row.mailto_3_middle_name, in_new_row.mailto_3_last_org_name,
            in_new_row.mailto_3_address_1, in_new_row.mailto_3_address_2, in_new_row.mailto_3_city, in_new_row.mailto_3_state, in_new_row.mailto_3_zipcode, 3);
    END IF;
  END IF;

  IF in_new_row.mailto_4_first_name IS DISTINCT FROM in_old_row.mailto_4_first_name 
     OR in_new_row.mailto_4_middle_name IS DISTINCT FROM in_old_row.mailto_4_middle_name
     OR in_new_row.mailto_4_last_org_name IS DISTINCT FROM in_old_row.mailto_4_last_org_name
     OR in_new_row.mailto_4_address_1 IS DISTINCT FROM in_old_row.mailto_4_address_1
     OR in_new_row.mailto_4_address_2 IS DISTINCT FROM in_old_row.mailto_4_address_2
     OR in_new_row.mailto_4_city IS DISTINCT FROM in_old_row.mailto_4_city
     OR in_new_row.mailto_4_state IS DISTINCT FROM in_old_row.mailto_4_state
     OR in_new_row.mailto_4_zipcode IS DISTINCT FROM in_old_row.mailto_4_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_4_first_name, in_new_row.mailto_4_middle_name, in_new_row.mailto_4_last_org_name,
              in_new_row.mailto_4_address_1, in_new_row.mailto_4_address_2, in_new_row.mailto_4_city, in_new_row.mailto_4_state, in_new_row.mailto_4_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 4;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_4_first_name, in_new_row.mailto_4_middle_name, in_new_row.mailto_4_last_org_name,
            in_new_row.mailto_4_address_1, in_new_row.mailto_4_address_2, in_new_row.mailto_4_city, in_new_row.mailto_4_state, in_new_row.mailto_4_zipcode, 4);
    END IF;
  END IF;

  IF in_new_row.mailto_5_first_name IS DISTINCT FROM in_old_row.mailto_5_first_name 
     OR in_new_row.mailto_5_middle_name IS DISTINCT FROM in_old_row.mailto_5_middle_name
     OR in_new_row.mailto_5_last_org_name IS DISTINCT FROM in_old_row.mailto_5_last_org_name
     OR in_new_row.mailto_5_address_1 IS DISTINCT FROM in_old_row.mailto_5_address_1
     OR in_new_row.mailto_5_address_2 IS DISTINCT FROM in_old_row.mailto_5_address_2
     OR in_new_row.mailto_5_city IS DISTINCT FROM in_old_row.mailto_5_city
     OR in_new_row.mailto_5_state IS DISTINCT FROM in_old_row.mailto_5_state
     OR in_new_row.mailto_5_zipcode IS DISTINCT FROM in_old_row.mailto_5_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_5_first_name, in_new_row.mailto_5_middle_name, in_new_row.mailto_5_last_org_name,
              in_new_row.mailto_5_address_1, in_new_row.mailto_5_address_2, in_new_row.mailto_5_city, in_new_row.mailto_5_state, in_new_row.mailto_5_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 5;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_5_first_name, in_new_row.mailto_5_middle_name, in_new_row.mailto_5_last_org_name,
            in_new_row.mailto_5_address_1, in_new_row.mailto_5_address_2, in_new_row.mailto_5_city, in_new_row.mailto_5_state, in_new_row.mailto_5_zipcode, 5);
    END IF;
  END IF;

  IF in_new_row.mailto_6_first_name IS DISTINCT FROM in_old_row.mailto_6_first_name 
     OR in_new_row.mailto_6_middle_name IS DISTINCT FROM in_old_row.mailto_6_middle_name
     OR in_new_row.mailto_6_last_org_name IS DISTINCT FROM in_old_row.mailto_6_last_org_name
     OR in_new_row.mailto_6_address_1 IS DISTINCT FROM in_old_row.mailto_6_address_1
     OR in_new_row.mailto_6_address_2 IS DISTINCT FROM in_old_row.mailto_6_address_2
     OR in_new_row.mailto_6_city IS DISTINCT FROM in_old_row.mailto_6_city
     OR in_new_row.mailto_6_state IS DISTINCT FROM in_old_row.mailto_6_state
     OR in_new_row.mailto_6_zipcode IS DISTINCT FROM in_old_row.mailto_6_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_6_first_name, in_new_row.mailto_6_middle_name, in_new_row.mailto_6_last_org_name,
              in_new_row.mailto_6_address_1, in_new_row.mailto_6_address_2, in_new_row.mailto_6_city, in_new_row.mailto_6_state, in_new_row.mailto_6_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 6;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_6_first_name, in_new_row.mailto_6_middle_name, in_new_row.mailto_6_last_org_name,
            in_new_row.mailto_6_address_1, in_new_row.mailto_6_address_2, in_new_row.mailto_6_city, in_new_row.mailto_6_state, in_new_row.mailto_6_zipcode, 6);
    END IF;
  END IF;

  IF in_new_row.mailto_7_first_name IS DISTINCT FROM in_old_row.mailto_7_first_name 
     OR in_new_row.mailto_7_middle_name IS DISTINCT FROM in_old_row.mailto_7_middle_name
     OR in_new_row.mailto_7_last_org_name IS DISTINCT FROM in_old_row.mailto_7_last_org_name
     OR in_new_row.mailto_7_address_1 IS DISTINCT FROM in_old_row.mailto_7_address_1
     OR in_new_row.mailto_7_address_2 IS DISTINCT FROM in_old_row.mailto_7_address_2
     OR in_new_row.mailto_7_city IS DISTINCT FROM in_old_row.mailto_7_city
     OR in_new_row.mailto_7_state IS DISTINCT FROM in_old_row.mailto_7_state
     OR in_new_row.mailto_7_zipcode IS DISTINCT FROM in_old_row.mailto_7_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_7_first_name, in_new_row.mailto_7_middle_name, in_new_row.mailto_7_last_org_name,
              in_new_row.mailto_7_address_1, in_new_row.mailto_7_address_2, in_new_row.mailto_7_city, in_new_row.mailto_7_state, in_new_row.mailto_7_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 7;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_7_first_name, in_new_row.mailto_7_middle_name, in_new_row.mailto_7_last_org_name,
            in_new_row.mailto_7_address_1, in_new_row.mailto_7_address_2, in_new_row.mailto_7_city, in_new_row.mailto_7_state, in_new_row.mailto_7_zipcode, 7);
    END IF;
  END IF;

  IF in_new_row.mailto_8_first_name IS DISTINCT FROM in_old_row.mailto_8_first_name 
     OR in_new_row.mailto_8_middle_name IS DISTINCT FROM in_old_row.mailto_8_middle_name
     OR in_new_row.mailto_8_last_org_name IS DISTINCT FROM in_old_row.mailto_8_last_org_name
     OR in_new_row.mailto_8_address_1 IS DISTINCT FROM in_old_row.mailto_8_address_1
     OR in_new_row.mailto_8_address_2 IS DISTINCT FROM in_old_row.mailto_8_address_2
     OR in_new_row.mailto_8_city IS DISTINCT FROM in_old_row.mailto_8_city
     OR in_new_row.mailto_8_state IS DISTINCT FROM in_old_row.mailto_8_state
     OR in_new_row.mailto_8_zipcode IS DISTINCT FROM in_old_row.mailto_8_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_8_first_name, in_new_row.mailto_8_middle_name, in_new_row.mailto_8_last_org_name,
              in_new_row.mailto_8_address_1, in_new_row.mailto_8_address_2, in_new_row.mailto_8_city, in_new_row.mailto_8_state, in_new_row.mailto_8_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 8;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_8_first_name, in_new_row.mailto_8_middle_name, in_new_row.mailto_8_last_org_name,
            in_new_row.mailto_8_address_1, in_new_row.mailto_8_address_2, in_new_row.mailto_8_city, in_new_row.mailto_8_state, in_new_row.mailto_8_zipcode, 8);
    END IF;
  END IF;

  IF in_new_row.mailto_9_first_name IS DISTINCT FROM in_old_row.mailto_9_first_name 
     OR in_new_row.mailto_9_middle_name IS DISTINCT FROM in_old_row.mailto_9_middle_name
     OR in_new_row.mailto_9_last_org_name IS DISTINCT FROM in_old_row.mailto_9_last_org_name
     OR in_new_row.mailto_9_address_1 IS DISTINCT FROM in_old_row.mailto_9_address_1
     OR in_new_row.mailto_9_address_2 IS DISTINCT FROM in_old_row.mailto_9_address_2
     OR in_new_row.mailto_9_city IS DISTINCT FROM in_old_row.mailto_9_city
     OR in_new_row.mailto_9_state IS DISTINCT FROM in_old_row.mailto_9_state
     OR in_new_row.mailto_9_zipcode IS DISTINCT FROM in_old_row.mailto_9_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_9_first_name, in_new_row.mailto_9_middle_name, in_new_row.mailto_9_last_org_name,
              in_new_row.mailto_9_address_1, in_new_row.mailto_9_address_2, in_new_row.mailto_9_city, in_new_row.mailto_9_state, in_new_row.mailto_9_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 9;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_9_first_name, in_new_row.mailto_9_middle_name, in_new_row.mailto_9_last_org_name,
            in_new_row.mailto_9_address_1, in_new_row.mailto_9_address_2, in_new_row.mailto_9_city, in_new_row.mailto_9_state, in_new_row.mailto_9_zipcode, 9);
    END IF;
  END IF;

  IF in_new_row.mailto_10_first_name IS DISTINCT FROM in_old_row.mailto_10_first_name 
     OR in_new_row.mailto_10_middle_name IS DISTINCT FROM in_old_row.mailto_10_middle_name
     OR in_new_row.mailto_10_last_org_name IS DISTINCT FROM in_old_row.mailto_10_last_org_name
     OR in_new_row.mailto_10_address_1 IS DISTINCT FROM in_old_row.mailto_10_address_1
     OR in_new_row.mailto_10_address_2 IS DISTINCT FROM in_old_row.mailto_10_address_2
     OR in_new_row.mailto_10_city IS DISTINCT FROM in_old_row.mailto_10_city
     OR in_new_row.mailto_10_state IS DISTINCT FROM in_old_row.mailto_10_state
     OR in_new_row.mailto_10_zipcode IS DISTINCT FROM in_old_row.mailto_10_zipcode
  THEN
    UPDATE public.user_mailing_addresses
       SET (first_name, middle_name, last_org_name,
            address_1, address_2, city, state, zipcode)
           = (in_new_row.mailto_10_first_name, in_new_row.mailto_10_middle_name, in_new_row.mailto_10_last_org_name,
              in_new_row.mailto_10_address_1, in_new_row.mailto_10_address_2, in_new_row.mailto_10_city, in_new_row.mailto_10_state, in_new_row.mailto_10_zipcode)
     WHERE user_id = in_old_row.user_id
           AND sort_key = 10;

    IF NOT FOUND THEN
      INSERT INTO public.user_mailing_addresses
        (user_id, first_name, middle_name, last_org_name,
         address_1, address_2, city, state, zipcode, sort_key)
        VALUES
           (in_new_row.user_id, in_new_row.mailto_10_first_name, in_new_row.mailto_10_middle_name, in_new_row.mailto_10_last_org_name,
            in_new_row.mailto_10_address_1, in_new_row.mailto_10_address_2, in_new_row.mailto_10_city, in_new_row.mailto_10_state, in_new_row.mailto_10_zipcode, 10);
    END IF;
  END IF;
  END IF;

  RETURN;

END;
$body$;

CREATE OR REPLACE FUNCTION delete_mailto_address(in_old_row mailto_addresses)
  RETURNS void
  LANGUAGE 'sql' AS
$body$

  DELETE FROM mailto_addresses_orig
   WHERE user_id = $1.user_id;

$body$;

CREATE FUNCTION mailto_addresses_orig_update_trig_func()
RETURNS trigger
STRICT
LANGUAGE plpgsql AS $body$
BEGIN

  IF old.is_migrated = TRUE THEN
    RAISE EXCEPTION 'Unable to update row.  Row has been migrated to public.user_mailing_addresses.';
  END IF;

  RETURN NEW;

END;
$body$;

CREATE TRIGGER mailto_addresses_orig_update_trig
BEFORE UPDATE
    ON public.mailto_addresses_orig
   FOR EACH ROW
       EXECUTE PROCEDURE mailto_addresses_orig_update_trig_func();

COMMIT;
