BEGIN;

CREATE TABLE public.users (
  user_id serial NOT NULL,
  first_name text NOT NULL,
  middle_name text NOT NULL,
  last_name text NOT NULL
);

CREATE UNIQUE INDEX users_key on public.users(user_id);

CREATE TABLE public.mailto_addresses (
  user_id integer NOT NULL REFERENCES public.users(user_id),
  mailto_1_first_name text,
  mailto_1_middle_name text,
  mailto_1_last_org_name text,
  mailto_1_address_1 text,
  mailto_1_address_2 text,
  mailto_1_city text,
  mailto_1_state char(2),
  mailto_1_zipcode text,
  mailto_2_first_name text,
  mailto_2_middle_name text,
  mailto_2_last_org_name text,
  mailto_2_address_1 text,
  mailto_2_address_2 text,
  mailto_2_city text,
  mailto_2_state char(2),
  mailto_2_zipcode text,
  mailto_3_first_name text,
  mailto_3_middle_name text,
  mailto_3_last_org_name text,
  mailto_3_address_1 text,
  mailto_3_address_2 text,
  mailto_3_city text,
  mailto_3_state char(2),
  mailto_3_zipcode text,
  mailto_4_first_name text,
  mailto_4_middle_name text,
  mailto_4_last_org_name text,
  mailto_4_address_1 text,
  mailto_4_address_2 text,
  mailto_4_city text,
  mailto_4_state char(2),
  mailto_4_zipcode text,
  mailto_5_first_name text,
  mailto_5_middle_name text,
  mailto_5_last_org_name text,
  mailto_5_address_1 text,
  mailto_5_address_2 text,
  mailto_5_city text,
  mailto_5_state char(2),
  mailto_5_zipcode text,
  mailto_6_first_name text,
  mailto_6_middle_name text,
  mailto_6_last_org_name text,
  mailto_6_address_1 text,
  mailto_6_address_2 text,
  mailto_6_city text,
  mailto_6_state char(2),
  mailto_6_zipcode text,
  mailto_7_first_name text,
  mailto_7_middle_name text,
  mailto_7_last_org_name text,
  mailto_7_address_1 text,
  mailto_7_address_2 text,
  mailto_7_city text,
  mailto_7_state char(2),
  mailto_7_zipcode text,
  mailto_8_first_name text,
  mailto_8_middle_name text,
  mailto_8_last_org_name text,
  mailto_8_address_1 text,
  mailto_8_address_2 text,
  mailto_8_city text,
  mailto_8_state char(2),
  mailto_8_zipcode text,
  mailto_9_first_name text,
  mailto_9_middle_name text,
  mailto_9_last_org_name text,
  mailto_9_address_1 text,
  mailto_9_address_2 text,
  mailto_9_city text,
  mailto_9_state char(2),
  mailto_9_zipcode text,
  mailto_10_first_name text,
  mailto_10_middle_name text,
  mailto_10_last_org_name text,
  mailto_10_address_1 text,
  mailto_10_address_2 text,
  mailto_10_city text,
  mailto_10_state char(2),
  mailto_10_zipcode text
);

CREATE UNIQUE INDEX mailto_addresses_key on public.mailto_addresses(user_id);

COMMIT;
